<template>
    <div class="sw-gs-client-video">
        <template v-if="callIsSetup">

            <template v-if="isVideoLayerOpen">
                <SwButton class="sw-gs-hide-videos-action is-circle color-light"
                          :title="$t('Hide video')"
                          @click="toggleVideoLayer">
                    <SwGsIconCircleLeft class="color-dark-secondary size-sm"/>
                </SwButton>
            </template>
            <template v-else>
                <SwButton class="sw-gs-show-videos-action is-circle color-light"
                          :title="$t('Show video')"
                          @click="toggleVideoLayer">
                    <SwGsIconClient class="color-dark-secondary size-sm"></SwGsIconClient>
                </SwButton>
            </template>

            <div v-show="isVideoLayerOpen">
                <template v-if="hasMembers">
                    <div class="sw-gs-member-video-wrapper" :class="{'is-fullscreen': activeSpeakerFullscreen}">

                        <div class="sw-gs-member-video-wrapper">
                            <template v-if="activeSpeakerStream">
                                <video :srcObject.prop="activeSpeakerStream" autoPlay muted playsInline></video>
                            </template>

                            <div v-else class="sw-gs-member-placeholder">
                                <SwGsIconClient class="color-dark-secondary size-xxl"></SwGsIconClient>
                            </div>

                            <template v-if="activeSpeaker">
                                <div class="sw-gs-member-name">
                                    <span v-if="activeSpeaker.data.user_name">{{ activeSpeaker.data.user_name }}</span>
                                    <span v-else>{{ $t('Anonymous') }}</span>
                                </div>
                            </template>
                        </div>

                        <!-- Audio-streams -->
                        <div v-for="participant in memberParticipants" class="sw-gs-video-participant-audio-wrapper">
                            <template v-if="participantHasAudioStream(participant)">
                                <audio :key="`${participant.session_id}-audio`"
                                       :srcObject.prop="participant.streams.audio"
                                       ref="speakerAudios"
                                       autoplay></audio>
                            </template>
                        </div>

                        <div class="sw-gs-client-video-actions">
                            <SwButton class="sw-gs-client-video-action is-circle color-light"
                                      :title="$t('Toggle fullscreen')"
                                      @click="toggleGuideFullscreen">
                                <SwGsIconExpand v-if="!activeSpeakerFullscreen" class="color-dark-secondary size-sm"/>
                                <SwGsIconCompress v-else class="color-dark-secondary size-sm"/>
                            </SwButton>
                        </div>
                    </div>
                </template>

                <template v-if="!isAudioOnly">
                    <div class="sw-gs-client-video-wrapper">

                        <template v-if="ownVideoStream">
                            <video :srcObject.prop="ownVideoStream" autoPlay muted playsInline></video>
                        </template>
                        <template v-else>
                            <SwGsIconCameraOff class="no-cam-icon color-dark-secondary size-sm"/>
                        </template>

                        <div class="opacity-wrapper">
                            <div class="sw-gs-client-video-settings">
                                <template v-if="isBroadCastEnabled">
                                    <SwButton class="sw-gs-broadcast-toggle is-circle color-light"
                                              :title="$t('Broadcast mode is active')">
                                        <SwGsIconBroadcast class="size-sm color-dark-secondary"/>
                                    </SwButton>
                                </template>
                                <template v-else>

                                    <SwButton class="sw-gs-video-client-microphone-toggle color-light is-circle"
                                              :title="microphoneState === false ? $t('Unmute') : $t('Mute')"
                                              @click="toggleMicrophone()"
                                              :class="{ 'microphone-off': microphoneState === false }">
                                        <SwGsIconMicOff v-if="microphoneState === false" class="color-dark-secondary size-sm"/>
                                        <SwGsIconMicOn v-else class="color-dark-secondary size-sm"/>
                                    </SwButton>

                                    <SwButton v-if="videoChatEnabled && cameraCount > 0" class="sw-gs-video-client-camera-toggle color-light is-circle"
                                              :title="cameraState === false ? $t('Video on') : $t('Video off')"
                                              @click="toggleCamera()"
                                              :class="{ 'camera-off': cameraState === false }">
                                        <SwGsIconCameraOff v-if="cameraState === false" class="color-dark-secondary size-sm"/>
                                        <SwGsIconCameraOn v-else class="color-dark-secondary size-sm"/>
                                    </SwButton>

                                </template>
                            </div>

                            <template v-if="hasDevices()">
                                <template v-if="!isBroadCastEnabled">
                                    <div class="sw-gs-device-settings-toggle-wrapper">
                                        <SwButton class="sw-gs-device-settings-toggle color-light is-circle" @click="toggleDeviceSettings">
                                            <SwGsIconCog class="color-dark-secondary size-sm"></SwGsIconCog>
                                        </SwButton>
                                    </div>
                                </template>
                            </template>
                        </div>
                    </div>

                </template>
                <template v-else>
                    <div class="audio-only-wrapper">

                        <div class="opacity-wrapper">

                            <template v-if="isBroadCastEnabled">
                                <SwButton class="sw-gs-broadSwButtoncast-toggle is-circle color-light"
                                          :title="$t('Broadcast mode is active')">
                                    <SwGsIconBroadcast class="size-sm color-dark-secondary"/>
                                </SwButton>
                            </template>
                            <template v-else-if="microphoneCount > 0">
                                <SwButton class="sw-gs-video-client-microphone-toggle color-light is-circle"
                                          :title="microphoneState === false ? $t('Unmute') : $t('Mute')"
                                          @click="toggleMicrophone()"
                                          :class="{ 'microphone-off': microphoneState === false }">
                                    <SwGsIconMicOff v-if="microphoneState === false" class="color-dark-secondary size-sm"/>
                                    <SwGsIconMicOn v-else class="color-dark-secondary size-sm"/>
                                </SwButton>
                            </template>

                            <template v-if="hasDevices() && !isBroadCastEnabled">
                                <SwButton class="sw-gs-device-settings-toggle color-light is-circle" @click="toggleDeviceSettings">
                                    <SwGsIconCog class="color-dark-secondary size-sm"></SwGsIconCog>
                                </SwButton>
                            </template>
                        </div>
                    </div>
                </template>
            </div>
        </template>

        <SwGsDeviceSettings v-if="isDeviceSettingsOpen"/>
        <SwGsDeviceErrorModal v-if="deviceError"/>
    </div>
</template>

<script lang="ts">
import {
    SwGsIconMicOff,
    SwGsIconMicOn,
    SwGsIconCameraOn,
    SwGsIconCameraOff,
    SwGsIconPhoneOn,
    SwGsIconPhoneOff,
    SwGsIconExpand,
    SwGsIconCompress,
    SwGsIconClient,
    SwGsIconCog,
    SwGsIconCircleLeft,
    SwGsIconBroadcast
} from "../icons";
import SwButton from "@/components/atoms/SwButton.vue";
import { onMounted } from "@vue/composition-api";
import { useUIState } from "@shopware-pwa/composables";
import SwGsDeviceSettings from '../SwGsDeviceSettings.vue';
import SwGsDeviceErrorModal from '../modals/SwGsDeviceErrorModal.vue';
import { useVideoCall } from "../../logic/composables/useVideoCall";
import { useMediaDevices } from '../../logic/composables/useMediaDevices';

export default {
    name: "SwGsLayerVideoClient",
    components: {
        SwGsIconClient,
        SwGsIconCompress,
        SwButton,
        SwGsIconMicOff,
        SwGsIconMicOn,
        SwGsIconCameraOn,
        SwGsIconCameraOff,
        SwGsIconPhoneOn,
        SwGsIconPhoneOff,
        SwGsIconExpand,
        SwGsIconCog,
        SwGsDeviceSettings,
        SwGsIconCircleLeft,
        SwGsIconBroadcast,
        SwGsDeviceErrorModal
    },

    setup() {
        const {
            setup: setupCall,
            callIsSetup,
            ownParticipant,
            ownVideoStream,
            memberParticipants,
            hasMembers,
            memberCount,
            activeSpeaker,
            activeSpeakerStream,
            toggleMicrophone,
            microphoneState,
            toggleCamera,
            cameraState,
            isBroadCastEnabled,
            speakerAudios,
            videoChatEnabled,
            callEnabled
        } = useVideoCall();
        const { hasDevices, deviceError, hasSavedSettings, isAudioOnly, cameraCount, microphoneCount, speakerCount } = useMediaDevices();

        const { isOpen: activeSpeakerFullscreen, switchState: switchGuideFullscreenState } = useUIState({ stateName: "GS_VIDEO_GUIDE_FULLSCREEN_STATE" });
        const { isOpen: isDeviceSettingsOpen, switchState: switchDeviceSettingsState } = useUIState({ stateName: "GS_VIDEO_DEVICE_SETTINGS_STATE" });
        const { isOpen: isVideoLayerOpen, switchState: switchVideoLayerState } = useUIState({ stateName: "GS_VIDEO_LAYER_CLIENT_STATE" });

        setupCall();

        onMounted(async () => {
            toggleVideoLayer();
        });

        function toggleGuideFullscreen() {
            // close settings if fullscreen state changes
            switchDeviceSettingsState(false);
            switchGuideFullscreenState();
        }

        function toggleDeviceSettings() {
            // close fullscreen if settings state changes
            switchGuideFullscreenState(false);
            switchDeviceSettingsState();
        }

        function toggleVideoLayer() {
            switchDeviceSettingsState(false);
            switchGuideFullscreenState(false);
            switchVideoLayerState();
        }

        function participantHasAudioStream(participant) {
            return participant.data?.audio && participant.streams?.audio
        }

        return {
            callIsSetup,
            ownParticipant,
            ownVideoStream,
            isAudioOnly,
            cameraCount,
            microphoneCount,
            callEnabled,
            videoChatEnabled,
            speakerCount,
            memberParticipants,
            hasMembers,
            memberCount,
            activeSpeaker,
            activeSpeakerStream,
            toggleMicrophone,
            microphoneState,
            toggleCamera,
            cameraState,
            toggleGuideFullscreen,
            activeSpeakerFullscreen,
            isDeviceSettingsOpen,
            toggleDeviceSettings,
            toggleVideoLayer,
            isVideoLayerOpen,
            isBroadCastEnabled,
            hasDevices,
            hasSavedSettings,
            deviceError,
            speakerAudios,
            participantHasAudioStream,
        }
    }
}
</script>

<style lang="scss" scoped>
@import "@/assets/scss/variables";
@import "../../assets/scss/mixins/mediaQueries";

$videoWrapperBottomDistance: 20px;

// show video in 4:3
$videoWidth: 187px;
$videoHeight: $videoWidth * 0.75;

$fullscreenMaxHeight: calc(100vh - #{$videoHeight} - #{$videoWrapperBottomDistance} - (var(--spacer-xs) * 2));

.sw-gs-client-video {
    position: fixed;
    z-index: var(--helper-lay-over-sibling-z-index);
    left: 20px;
    bottom: $videoWrapperBottomDistance;
}

.sw-gs-client-video-wrapper {
    & .no-cam-icon {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
    }

    &:hover {
        .opacity-wrapper {
            opacity: 1;
        }
    }

    .opacity-wrapper {
        opacity: 0.25;
        transition: opacity 0.15s ease-in;
    }
}

.sw-gs-member-video-wrapper,
.sw-gs-client-video-wrapper {
    position: relative;
    border-radius: 10px;
    overflow: hidden;
    margin-top: var(--spacer-xs);
    background-color: var(--c-gray-variant);

    video {
        object-fit: cover;
        width: 100%;
        height: 100%;
    }
}

.sw-gs-member-video-wrapper {
    width: $videoWidth * 1.2;
    height: $videoHeight * 1.2;
    margin-top: 0;
}

.sw-gs-client-video-wrapper {
    width: $videoWidth;
    height: $videoHeight;
}

.sw-gs-member-placeholder {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
}

.sw-gs-member-name {
    position: absolute;
    width: 100%;
    bottom: 0;
    left: 50%;
    transform: translateX(-50%);
    text-align: center;
    background: rgba(0, 0, 0, 0.5);
    color: var(--c-white);

    span {
        padding: 0 10px;
    }
}

.sw-gs-hide-videos-action {
    margin-bottom: var(--spacer-xs);
    transform: rotate(-90deg);
}

.sw-gs-show-videos-action {
    margin-bottom: var(--spacer-xs);
}

.sw-gs-client-video-actions {
    position: absolute;
    right: var(--spacer-xs);
    top: var(--spacer-xs);
    display: flex;
}

.audio-only-wrapper {
    position: relative;

    .opacity-wrapper {
        padding-top: var(--spacer-xs);

        button {
            display: inline-block;
        }
    }
}

.sw-gs-client-video-settings {
    display: flex;
    flex-direction: column;
    position: absolute;
    left: var(--spacer-xs);
    top: var(--spacer-xs);

    &-audio-only {
        position: relative;
    }
}

.sw-gs-client-video-settings-btn {
    position: absolute;
    left: var(--spacer-xs);
    bottom: var(--spacer-xs);
}

.sw-gs-video-client-microphone-toggle,
.sw-gs-video-client-camera-toggle {
    margin-bottom: var(--spacer-xs);
}

.sw-gs-member-video-wrapper {
    &.is-fullscreen {
        width: calc(100vw - 30px);
        height: 65vh;
        max-height: $fullscreenMaxHeight;

        @include for-desktop-small {
            width: $videoWidth * 2.5;
            height: $videoHeight * 2.5;
        }

        @include for-desktop {
            width: $videoWidth * 4;
            height: $videoHeight * 4;
        }

        .sw-gs-member-video-wrapper {
            width: 100%;
            height: 100%;
        }
    }
}


.sw-gs-device-settings-toggle-wrapper {
    position: absolute;
    right: var(--spacer-xs);
    top: var(--spacer-xs);
}

::v-deep .sw-gs-device-settings-wrapper,
.sw-gs-client-device-error {
    position: absolute;
    width: 100%;
    left: 100%;
    margin-left: var(--spacer-xs);
    bottom: 0;
    background-color: var(--c-white);
    border: 1px solid var(--_c-gray-accent);
    border-radius: 10px;
    padding: var(--spacer-xs);
}

</style>
